function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "show", "animation", "duration", "maskAttribute", "caption", "captionAttribute", "icon", "contentAttribute", "submitCaption", "submitAttribute", "cancelCaption", "cancelAttribute", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useContext } from 'react';
import { createPortal } from 'react-dom';
import Context from "./../Context/instance.js";

// 弹框
/**
 * @deprecated since version 5.2.8
 * 请使用Modal
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Alert = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    show = _ref.show,
    _ref$animation = _ref.animation,
    animation = _ref$animation === void 0 ? 'zoom' : _ref$animation,
    duration = _ref.duration,
    _ref$maskAttribute = _ref.maskAttribute,
    maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
    caption = _ref.caption,
    _ref$captionAttribute = _ref.captionAttribute,
    captionAttribute = _ref$captionAttribute === void 0 ? {} : _ref$captionAttribute,
    icon = _ref.icon,
    _ref$contentAttribute = _ref.contentAttribute,
    contentAttribute = _ref$contentAttribute === void 0 ? {} : _ref$contentAttribute,
    submitCaption = _ref.submitCaption,
    _ref$submitAttribute = _ref.submitAttribute,
    submitAttribute = _ref$submitAttribute === void 0 ? {} : _ref$submitAttribute,
    cancelCaption = _ref.cancelCaption,
    _ref$cancelAttribute = _ref.cancelAttribute,
    cancelAttribute = _ref$cancelAttribute === void 0 ? {} : _ref$cancelAttribute,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };

  // 构建动画
  var animationClassName = '';
  switch (animation) {
    case 'slideLeft':
      animationClassName = 'popup-animation right-middle';
      break;
    case 'slideRight':
      animationClassName = 'popup-animation left-middle';
      break;
    case 'slideUp':
      animationClassName = 'popup-animation bottom-center';
      break;
    case 'slideDown':
      animationClassName = 'popup-animation top-center';
      break;
    case 'zoom':
      animationClassName = 'popup-animation middle';
      break;
    case 'fade':
      animationClassName = 'popup-animation middle';
      break;
    case 'none':
      animationClassName = '';
      break;
    default:
      animationClassName = 'popup-animation middle';
  }
  // 动画时长
  var durationStyle = {};
  if (typeof duration === 'number') {
    durationStyle = {
      WebkitTransitionDuration: duration + 'ms'
    };
  }
  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({
    ref: ref
  }, maskAttribute), {}, {
    className: "mask alert-mask".concat(maskAttribute.className ? ' ' + maskAttribute.className : '').concat(show ? ' active' : ''),
    style: Object.assign({}, durationStyle, maskAttribute.style || {}),
    children: /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
      "data-animation": animation
    }, others), {}, {
      className: "alert".concat(animationClassName ? ' ' + animationClassName : '').concat(others.className ? ' ' + others.className : '').concat(show ? ' active' : ''),
      style: Object.assign({}, durationStyle, others.style || {}),
      children: [/*#__PURE__*/_jsxs("div", {
        className: "alert-body",
        children: [caption && /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, captionAttribute), {}, {
          className: "alert-caption".concat(captionAttribute.className ? ' ' + captionAttribute.className : ''),
          children: caption
        })), /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, contentAttribute), {}, {
          className: "alert-content".concat(contentAttribute.className ? ' ' + contentAttribute.className : ''),
          children: [icon, children]
        }))]
      }), /*#__PURE__*/_jsxs("div", {
        className: "alert-footer",
        children: [cancelAttribute.onClick && /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, cancelAttribute), {}, {
          className: "alert-cancel button".concat(cancelAttribute.className ? ' ' + cancelAttribute.className : ''),
          children: cancelCaption || locale('取消', 'cancel')
        })), submitAttribute.onClick && /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, submitAttribute), {}, {
          className: "alert-submit button".concat(submitAttribute.className ? ' ' + submitAttribute.className : ''),
          children: submitCaption || locale('确定', 'ok')
        }))]
      })]
    }))
  })), portal || context.portal || document.getElementById('root') || document.body);
});
export default Alert;