function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect } from 'react';
import Alert from "./../Alert";
import InputDate from "./../InputDate";
import locale from "./../locale";

// 自定义时间
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function DateRange(_ref) {
  var caption = _ref.caption,
    type = _ref.type,
    start = _ref.start,
    end = _ref.end,
    _ref$startInputDatePr = _ref.startInputDateProps,
    startInputDateProps = _ref$startInputDatePr === void 0 ? {} : _ref$startInputDatePr,
    _ref$endInputDateProp = _ref.endInputDateProps,
    endInputDateProps = _ref$endInputDateProp === void 0 ? {} : _ref$endInputDateProp,
    visible = _ref.visible,
    onVisibleChange = _ref.onVisibleChange,
    onSubmitBefore = _ref.onSubmitBefore,
    onChange = _ref.onChange;
  // 自定义日期数据
  var _useState = useState(start),
    _useState2 = _slicedToArray(_useState, 2),
    customStart = _useState2[0],
    setCustomStart = _useState2[1];
  var _useState3 = useState(end),
    _useState4 = _slicedToArray(_useState3, 2),
    customEnd = _useState4[0],
    setCustomEnd = _useState4[1];
  useEffect(function () {
    setCustomStart(start);
    setCustomEnd(end);
  }, [start, end]);

  // 点击自定义取消
  function handleCustomCancel() {
    if (onVisibleChange) onVisibleChange(false);
    setCustomStart(start);
    setCustomEnd(end);
  }
  // 点击自定义确定
  function handleCustomSubmit(e) {
    if (typeof onSubmitBefore === 'function') {
      if (!onSubmitBefore(e, [customStart, customEnd])) {
        return;
      }
    }
    if (onChange) {
      onChange(e, [customStart, customEnd]);
    }
    if (onVisibleChange) onVisibleChange(false);
  }

  // 修改自定义开始时间
  function handleCustomStartDate(e, value) {
    setCustomStart(value);
  }

  // 修改自定义结束时间
  function handleCustomEndDate(e, value) {
    setCustomEnd(value);
  }
  return /*#__PURE__*/_jsxs(Alert, {
    caption: caption || '',
    show: visible,
    submitAttribute: {
      onClick: handleCustomSubmit
    },
    cancelAttribute: {
      onClick: handleCustomCancel
    },
    children: [/*#__PURE__*/_jsx(InputDate, _objectSpread({
      type: type || 'date',
      max: customEnd,
      value: customStart || start || '',
      onChange: handleCustomStartDate,
      placeholder: locale('请选择'),
      className: "datepopover-dialog-inputbox",
      pickerProps: {
        maskAttribute: {
          style: {
            zIndex: '11'
          }
        }
      }
    }, startInputDateProps || {})), /*#__PURE__*/_jsx(InputDate, _objectSpread({
      type: type || 'date',
      min: customStart,
      value: customEnd || end || '',
      onChange: handleCustomEndDate,
      placeholder: locale('请选择'),
      className: "datepopover-dialog-inputbox",
      pickerProps: {
        maskAttribute: {
          style: {
            zIndex: '11'
          }
        }
      }
    }, endInputDateProps || {}))]
  });
}
export default DateRange;