function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["type", "autoFit", "readOnly", "disabled", "inputProps", "defaultValue", "value", "formatter", "precision", "max", "min", "placeholder", "maxLength", "autoFocus", "autoSelect", "licon", "liconProps", "ricon", "riconProps", "allowClear", "clearProps", "onClearVisibleChange", "rcaption", "children", "onClick", "onCompositionStart", "onCompositionUpdate", "onCompositionEnd", "onInput", "onChange", "onBlur", "onFocus"],
  _excluded2 = ["visible"],
  _excluded3 = ["style", "className"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import MathJs from "./../../math";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var InputText = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'text' : _ref$type,
    autoFit = _ref.autoFit,
    readOnly = _ref.readOnly,
    disabled = _ref.disabled,
    _ref$inputProps = _ref.inputProps,
    inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
    defaultValue = _ref.defaultValue,
    value = _ref.value,
    formatter = _ref.formatter,
    precision = _ref.precision,
    max = _ref.max,
    min = _ref.min,
    placeholder = _ref.placeholder,
    maxLength = _ref.maxLength,
    autoFocus = _ref.autoFocus,
    autoSelect = _ref.autoSelect,
    licon = _ref.licon,
    liconProps = _ref.liconProps,
    ricon = _ref.ricon,
    riconProps = _ref.riconProps,
    allowClear = _ref.allowClear,
    clearProps = _ref.clearProps,
    onClearVisibleChange = _ref.onClearVisibleChange,
    rcaption = _ref.rcaption,
    children = _ref.children,
    onClick = _ref.onClick,
    onCompositionStart = _ref.onCompositionStart,
    onCompositionUpdate = _ref.onCompositionUpdate,
    onCompositionEnd = _ref.onCompositionEnd,
    onInput = _ref.onInput,
    onChange = _ref.onChange,
    onBlur = _ref.onBlur,
    onFocus = _ref.onFocus,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  var inputRef = useRef(null);
  var fitRef = useRef(null);
  var clearRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      inputDOM: inputRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInputDOM: function getInputDOM() {
        return inputRef.current;
      },
      correctValue: correctValue,
      focus: focus,
      updateClear: updateClear
    };
  });
  useEffect(function () {
    var val = inputRef.current.value;

    // 自动获取焦点
    if (autoFocus) {
      focus();
    }

    // 矫正为正确的值
    if (inputRef.current) {
      // 矫正为正确的值
      val = correctValue(val, true);
      // 格式化输入
      val = correctFormatter(val);

      // 矫正后的值和矫正前的值不一致, 需要强制修改文本框内的值
      if (inputRef.current && val !== inputRef.current.value) {
        inputRef.current.value = val;
      }
    }

    // 更新清除按钮和自适应的高度
    updateClear(val);
    updateAutoFit(val);
  }, []); // eslint-disable-line

  useEffect(function () {
    updateContainer();
  }, [value]); // eslint-disable-line

  // 更新文本框高度和清空按钮
  function updateContainer() {
    if (!(rootRef !== null && rootRef !== void 0 && rootRef.current)) return;
    if (rootRef.current.inputTimeout) {
      clearTimeout(rootRef.current.inputTimeout);
    }
    rootRef.current.inputTimeout = setTimeout(function () {
      if (!(inputRef !== null && inputRef !== void 0 && inputRef.current)) return;
      var val = inputRef.current.value;
      // 更新清除按钮和自适应的高度
      updateClear(val);
      updateAutoFit(val);
    }, 100);
  }

  // 更新清除按钮
  function updateClear(val) {
    var _clearRef$current2;
    if (val === undefined) {
      var _inputRef$current;
      // eslint-disable-next-line
      val = (inputRef === null || inputRef === void 0 ? void 0 : (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.value) || '';
    } else if (typeof val === 'number') {
      // eslint-disable-next-line
      val = String(val);
    }
    // 不显示清空
    if (!allowClear) {
      var _clearRef$current, _clearRef$current$cla;
      if (clearRef !== null && clearRef !== void 0 && (_clearRef$current = clearRef.current) !== null && _clearRef$current !== void 0 && (_clearRef$current$cla = _clearRef$current.classList) !== null && _clearRef$current$cla !== void 0 && _clearRef$current$cla.add) {
        clearRef.current.classList.add('hide');
      }
      return;
    }

    // 根据值判断是否显示清空
    if (clearRef !== null && clearRef !== void 0 && (_clearRef$current2 = clearRef.current) !== null && _clearRef$current2 !== void 0 && _clearRef$current2.classList) {
      var _ricon2, _ricon2$classList;
      // 右侧图标, 当allowClear为exclusion-ricon时，则与ricon互斥
      var _ricon = clearRef.current.nextElementSibling;
      if (!_ricon || !((_ricon2 = _ricon) !== null && _ricon2 !== void 0 && (_ricon2$classList = _ricon2.classList) !== null && _ricon2$classList !== void 0 && _ricon2$classList.contains('ricon'))) {
        _ricon = null;
      }

      // 有值隐藏清除
      if (val) {
        clearRef.current.classList.remove('hide');
        typeof onClearVisibleChange === 'function' && onClearVisibleChange(true);

        // 清除图标显示时, 隐藏右侧图标
        if (allowClear === 'exclusion-ricon' && _ricon) {
          _ricon.classList.add('hide');
        }
      }
      // 无值显示清除
      else {
        clearRef.current.classList.add('hide');
        typeof onClearVisibleChange === 'function' && onClearVisibleChange(false);

        // 清除图标隐藏时, 显示右侧图标
        if (allowClear === 'exclusion-ricon' && _ricon) {
          _ricon.classList.remove('hide');
        }
      }
    }
  }

  // 自动扩充功能
  function updateAutoFit(val) {
    if (!autoFit) return;
    fitRef.current.children[0].innerText = val;
    // 多行文本框使用样式宽高100%, 放弃使用js控制高度
    // inputRef.current.style.height = fitRef.current.clientHeight + 'px'
  }

  // 矫正最大长度与小数位
  function correctMaxLength(val) {
    // eslint-disable-next-line
    if (typeof val === 'number') val = String(val);

    // 最大长度
    if (maxLength && val && val.length > maxLength) {
      // eslint-disable-next-line
      val = val.substring(0, maxLength);
    }
    return val;
  }

  // 矫正formatter
  function correctFormatter(val) {
    if (typeof formatter === 'function') {
      var formatterValue = formatter(val);
      if (typeof formatterValue === 'string' || typeof formatterValue === 'number') {
        // eslint-disable-next-line
        val = formatterValue;
      }
    }
    return val;
  }

  // 矫正小数位截取
  function correctPrecision(val, fixedPrecision) {
    // 符合截取条件时
    if (type === 'number' && typeof precision === 'number' && !isNaN(val) && val !== (null || '')) {
      if (fixedPrecision) {
        // eslint-disable-next-line
        val = Number(val || 0).toFixed(precision);
      } else {
        // eslint-disable-next-line
        val = MathJs.fixed(val, precision);
      }
    }
    return val;
  }

  // 矫正最大长度和小数位截取
  function correctValue(val, fixedPrecision) {
    if (val === undefined || val === '') return val;
    if (typeof val !== 'string' && typeof val !== 'number') return '';

    // 最大长度载取
    // eslint-disable-next-line
    val = correctMaxLength(val);

    // 小数位截取
    // eslint-disable-next-line
    val = correctPrecision(val, fixedPrecision);
    return val;
  }

  // 获取焦点
  function focus() {
    if (disabled || readOnly || !inputRef.current) return;
    inputRef.current.focus();
    // 只有获取焦点以后才能选中
    if (autoSelect) {
      inputRef.current.select();
    }
  }

  // 获取焦点时, 如果readOnly或者disabled时, 需要立即失去焦点, 解决ios会出现底栏的问题
  function handleFocus(e) {
    if (readOnly || disabled) {
      e.target.blur();
      return;
    }
    if (onFocus) onFocus(e);
  }

  // 清空按钮控制
  function handleInput(e) {
    // 非受控组件需要操作DOM
    if (value === undefined) {
      updateContainer();
    }

    // Callback
    if (onInput) onInput(e);
  }

  // 修改值
  function handleChange(e) {
    var target = e.target;
    var val = target.value;
    // 此处不宜用target?.validity?.badInput矫正数值, 因为ios上.也返回空

    // 矫正maxLength和小数点位数(不能矫正其它框，因为矫正将无法输入中文)
    if (val && type === 'number') {
      // eslint-disable-next-line
      val = correctValue(val);
      if (target.value !== val) {
        target.value = val;
      }
    }
    if (onChange) {
      if (val && type === 'number') {
        // eslint-disable-next-line
        val = Number(val);
      }
      onChange(val);
    }
  }

  // 数值框失去焦点, 校验最大值和最小值
  function handleBlur(e) {
    if (readOnly || disabled) {
      return;
    }
    var target = e.target;
    var val = target.value;

    // 数值框失焦时需要矫正数值
    if (type === 'number') {
      // 正常输入：矫正最大最小值、小数点、最大长度
      if (val && !isNaN(val)) {
        if (typeof max === 'number') {
          if (Number(val) > Number(max)) val = max;
        }
        if (typeof min === 'number') {
          if (Number(val) < Number(min)) val = min;
        }

        // 纠正数字
        // eslint-disable-next-line
        val = correctValue(val, true);
      }
      // 输入错误或真的为空：用于解决ios可以输入字母中文等问题
      else {
        val = '';
      }

      // 格式化输入
      val = correctFormatter(val);

      // 赋值
      target.value = val;

      // 修改完回调
      if (val !== value) {
        if (onChange) onChange(val);
      }
    }
    if (onBlur) onBlur(e);
  }

  // 点击清除
  function handleClear(e) {
    e.stopPropagation();
    // 获取焦点
    focus();

    // Callback
    typeof onChange === 'function' && onChange('');
    typeof (clearProps === null || clearProps === void 0 ? void 0 : clearProps.onClick) === 'function' && clearProps.onClick(e, '');

    // 非受控组件需要操作DOM
    if (value === undefined) {
      var _inputRef$current2;
      updateContainer();
      if (inputRef !== null && inputRef !== void 0 && (_inputRef$current2 = inputRef.current) !== null && _inputRef$current2 !== void 0 && _inputRef$current2.value) {
        inputRef.current.value = '';
      }
    } else {
      // 正常onChange会触发value监听, 但有可能value未变, 手动再触发一遍清空
      updateClear('');
    }
  }

  // render
  function getInputDOM() {
    // 剔除掉onClick事件, 因为在容器onClick已经回调了
    var inputVisible = inputProps.visible,
      otherInputProps = _objectWithoutProperties(inputProps, _excluded2);
    // if (inputVisible === false) return null
    // autoFit类型
    if (autoFit) {
      var style = otherInputProps.style,
        className = otherInputProps.className,
        otherFitProps = _objectWithoutProperties(otherInputProps, _excluded3);
      return /*#__PURE__*/_jsxs("div", {
        className: "input-fit-wrapper".concat(inputVisible === false ? ' hide' : ''),
        children: [/*#__PURE__*/_jsx("textarea", _objectSpread(_objectSpread({
          ref: inputRef
          // className={className}
          ,
          className: "input-fit",
          style: style
        }, otherFitProps), {}, {
          autoFocus: autoFocus,
          value: value,
          defaultValue: defaultValue,
          maxLength: maxLength,
          readOnly: readOnly,
          disabled: disabled,
          placeholder: placeholder,
          onChange: handleChange,
          onInput: handleInput,
          onBlur: handleBlur,
          onFocus: handleFocus
        })), /*#__PURE__*/_jsx("pre", {
          ref: fitRef,
          style: style,
          className: className,
          children: /*#__PURE__*/_jsx("span", {})
        })]
      });
    }
    // textarea类型
    if (type === 'textarea') {
      // 如果值绑定属性,则只有通过父组件的prop来改变值
      return /*#__PURE__*/_jsx("textarea", _objectSpread(_objectSpread({
        ref: inputRef
      }, otherInputProps), {}, {
        autoFocus: autoFocus,
        value: value,
        defaultValue: defaultValue,
        maxLength: maxLength,
        readOnly: readOnly,
        disabled: disabled,
        placeholder: placeholder,
        onChange: handleChange,
        onInput: handleInput,
        onBlur: handleBlur,
        onFocus: handleFocus,
        className: "input-textarea".concat(otherInputProps.className ? ' ' + otherInputProps.className : '').concat(inputVisible === false ? ' hide' : '')
      }));
    }
    // 其它类型
    return /*#__PURE__*/_jsx("input", _objectSpread(_objectSpread({
      ref: inputRef,
      type: type
    }, otherInputProps), {}, {
      className: "input-text".concat(otherInputProps.className ? ' ' + otherInputProps.className : '').concat(inputVisible === false ? ' hide' : ''),
      defaultValue: defaultValue,
      value: value,
      min: typeof min === 'number' ? min : '',
      max: typeof max === 'number' ? max : '',
      maxLength: maxLength,
      disabled: disabled,
      readOnly: readOnly,
      placeholder: placeholder,
      onChange: handleChange,
      onInput: handleInput,
      autoFocus: autoFocus,
      onBlur: handleBlur,
      onFocus: handleFocus
    }));
  }
  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "input-wrapper".concat(props.className ? ' ' + props.className : '').concat(disabled ? ' disabled' : '').concat(readOnly ? ' readonly' : ''),
    onClick: onClick,
    ref: rootRef,
    children: [licon && licon, liconProps && /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({}, liconProps), {}, {
      className: "licon icon".concat(liconProps !== null && liconProps !== void 0 && liconProps.className ? ' ' + (liconProps === null || liconProps === void 0 ? void 0 : liconProps.className) : '')
    })), getInputDOM(), children && children, /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({
      ref: clearRef
    }, clearProps), {}, {
      className: "input-clear".concat(clearProps !== null && clearProps !== void 0 && clearProps.className ? ' ' + (clearProps === null || clearProps === void 0 ? void 0 : clearProps.className) : ''),
      onClick: handleClear
    })), riconProps && /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({}, riconProps), {}, {
      className: "ricon icon".concat(riconProps !== null && riconProps !== void 0 && riconProps.className ? ' ' + (riconProps === null || riconProps === void 0 ? void 0 : riconProps.className) : '')
    })), ricon && ricon, rcaption && rcaption]
  }));
});
export default InputText;