function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["ak", "value", "onChange", "modal", "visible", "onVisibleChange"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect, useState } from 'react';
import locale from "./../../locale";
import addHistory from "./addHistory";
import Toast from "./../../Toast";
import Loading from "./../../Loading";
import MapUtil from "./../../MapUtil";
import Layout from "./../../Layout";
import Modal from "./../../Modal";
import Head from "./../../Picker/Modal/Head";
import Main from "./../Main";
import Footer from "./Footer";

// 地图标注
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var LocationModal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _value;
  var ak = _ref.ak,
    _ref$value = _ref.value,
    originValue = _ref$value === void 0 ? null : _ref$value,
    onChange = _ref.onChange,
    modal = _ref.modal,
    visible = _ref.visible,
    onVisibleChange = _ref.onVisibleChange,
    props = _objectWithoutProperties(_ref, _excluded);
  // 经纬度
  var _useState = useState(originValue),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];

  // 加载中
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    loaded = _useState4[0],
    setLoaded = _useState4[1];
  useEffect(function () {
    if (!visible) return;
    // 无法使用地图
    if (!window.BMap && !ak) {
      Toast.show({
        content: locale('请传入百度地图ak', 'hint_map_ak')
      });
      return;
    }

    // 正确
    if (window.BMap) {
      loaded = true;
      setLoaded(true);
      addHistory({
        modal: modal,
        loaded: loaded
      });
      return;
    }
    var loadErrMsg = locale('地图库加载失败, 请稍后再试', 'hint_map_failed_load');
    if (ak) {
      Loading.show();
      MapUtil.load({
        ak: ak,
        success: function success() {
          Loading.hide();
          loaded = true;
          setLoaded(true);
          addHistory({
            modal: modal,
            loaded: loaded
          });
        },
        fail: function fail() {
          Loading.hide();
          Toast.show({
            content: loadErrMsg
          });
        }
      });
      return;
    }
    Toast.show({
      content: loadErrMsg
    });

    // eslint-disable-next-line
  }, [visible]);

  // 页面模式: 路由监听
  useEffect(function () {
    if (modal !== 'page') return;
    window.removeEventListener('popstate', handleBack, false);
    window.addEventListener('popstate', handleBack, false);
    return function () {
      window.removeEventListener('popstate', handleBack, false);
    };
    // eslint-disable-next-line
  }, []);
  useEffect(function () {
    setValue(originValue);
  }, [JSON.stringify(originValue)]); // eslint-disable-line

  // 返回路由监听
  function handleBack() {
    if (window.location.href.indexOf('modalPage=1') !== -1) {
      window.history.go(-1);
    }
    onVisibleChange && onVisibleChange(false);
  }

  // 点击确定和取消
  function handleOk() {
    if (onChange) onChange(value);
    handleBack();
  }
  if (!loaded) return null;

  // Page显示
  if (modal === 'page') {
    return /*#__PURE__*/_jsx(Layout, _objectSpread(_objectSpread({
      ref: ref,
      className: "location-page".concat(props !== null && props !== void 0 && props.className ? ' ' + props.className : '').concat(visible ? '' : ' hide')
    }, props), {}, {
      children: /*#__PURE__*/_jsx(Main, {
        ak: ak,
        type: visible,
        value: value,
        onChange: setValue
        // 底
        ,
        footerRender: function footerRender() {
          return visible === 'choose' ? /*#__PURE__*/_jsx(Footer, {
            onOk: handleOk,
            onClear: function onClear() {
              value = null;
              setValue(null);
              handleOk();
            }
          }) : null;
        }
      })
    }));
  }
  return /*#__PURE__*/_jsxs(Modal, _objectSpread(_objectSpread({
    ref: ref,
    visible: visible,
    onVisibleChange: onVisibleChange,
    style: {
      height: '95%'
    }
  }, props), {}, {
    animation: "slideUp",
    className: "location-modal",
    children: [/*#__PURE__*/_jsx(Head, {
      captionProps: {
        caption: locale('选择地址', 'picker_location_title')
      },
      onSubmitClick: visible === 'choose' && (_value = value) !== null && _value !== void 0 && _value.value ? handleOk : null,
      onCancelClick: handleBack
    }), /*#__PURE__*/_jsx(Main, {
      ak: ak,
      type: visible,
      value: value,
      onChange: setValue
    })]
  }));
});
export default LocationModal;