function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["drag", "transition", "lSide", "lSideAttribute", "rSide", "rSideAttribute", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useRef, forwardRef, useImperativeHandle } from 'react';
import Page from "./../Page";
import Instance from "./instance.js";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var PagePull = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$drag = _ref.drag,
    drag = _ref$drag === void 0 ? true : _ref$drag,
    _ref$transition = _ref.transition,
    transition = _ref$transition === void 0 ? 'push' : _ref$transition,
    lSide = _ref.lSide,
    _ref$lSideAttribute = _ref.lSideAttribute,
    lSideAttribute = _ref$lSideAttribute === void 0 ? {} : _ref$lSideAttribute,
    rSide = _ref.rSide,
    _ref$rSideAttribute = _ref.rSideAttribute,
    rSideAttribute = _ref$rSideAttribute === void 0 ? {} : _ref$rSideAttribute,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useEffect(function () {
    if (instance.current) return;
    initInstance();
    // eslint-disable-next-line
  }, []);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  function initInstance() {
    if (!(rootRef !== null && rootRef !== void 0 && rootRef.current)) return;
    instance.current = new Instance(rootRef.current, {
      drag: true,
      transition: transition || 'push',
      onShowedLeft: lSideAttribute.onShowed,
      onShowedRight: rSideAttribute.onShowed
    });
  }

  // 过滤已经回调的属性
  function filterProps(props) {
    if (!props) return props;
    var propsed = {};
    for (var n in props) {
      if (n !== 'onShowed') {
        propsed[n] = props[n];
      }
    }
    return propsed;
  }

  // 剔除掉onShowed事件, 因为在instance时已经回调了
  lSideAttribute = filterProps(lSideAttribute);
  rSideAttribute = filterProps(rSideAttribute);
  return /*#__PURE__*/_jsxs("div", {
    className: "page-pull",
    ref: rootRef,
    children: [/*#__PURE__*/_jsxs(Page, _objectSpread(_objectSpread({}, others), {}, {
      children: [children, /*#__PURE__*/_jsx("div", {
        className: "mask"
      })]
    })), lSide && /*#__PURE__*/_jsx("aside", _objectSpread(_objectSpread({}, lSideAttribute), {}, {
      className: "page-side-left".concat(lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
      "data-transition": transition,
      children: lSide
    })), rSide && /*#__PURE__*/_jsx("aside", _objectSpread(_objectSpread({}, lSideAttribute), {}, {
      className: "page-side-right".concat(lSideAttribute.className ? ' ' + lSideAttribute.className : ''),
      "data-transition": transition,
      children: rSide
    }))]
  });
});
export default PagePull;