function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "data", "dataFormat", "split", "type", "show", "value", "selected", "maskAttribute", "submitAttribute", "cancelAttribute", "onScrollEnd"],
  _excluded2 = ["caption", "onClick"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useContext, useEffect } from 'react';
import { createPortal } from 'react-dom';
import treeData from "./../PickerDistrict/china.js";
import Instance from "./instance.js";
import Context from "../Context/instance.js";

/**
 * @deprecated since version 5.2.8
 * use Cascader.DistrictCombo instead
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var PickerCity = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    data = _ref.data,
    _ref$dataFormat = _ref.dataFormat,
    dataFormat = _ref$dataFormat === void 0 ? {
      // {idPropertyName: 'id', namePropertyName: 'name', childPropertyName: 'children'}
      idPropertyName: 'id',
      namePropertyName: 'name',
      childPropertyName: 'children'
    } : _ref$dataFormat,
    _ref$split = _ref.split,
    split = _ref$split === void 0 ? '-' : _ref$split,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'district' : _ref$type,
    _ref$show = _ref.show,
    show = _ref$show === void 0 ? false : _ref$show,
    value = _ref.value,
    selected = _ref.selected,
    _ref$maskAttribute = _ref.maskAttribute,
    maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
    _ref$submitAttribute = _ref.submitAttribute,
    submitAttribute = _ref$submitAttribute === void 0 ? {} : _ref$submitAttribute,
    _ref$cancelAttribute = _ref.cancelAttribute,
    cancelAttribute = _ref$cancelAttribute === void 0 ? {} : _ref$cancelAttribute,
    onScrollEnd = _ref.onScrollEnd,
    others = _objectWithoutProperties(_ref, _excluded);
  var refEl = useRef(null);
  useImperativeHandle(ref, function () {
    return refEl.current;
  });
  var instance = useRef(null);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };
  useEffect(function () {
    initInstance();
  }, []); // eslint-disable-line

  useEffect(function () {
    if (!instance.current) return;
    if (show) {
      if (data) {
        instance.current.setData(data, {
          childPropertyName: dataFormat.childPropertyName,
          idPropertyName: dataFormat.idPropertyName,
          namePropertyName: dataFormat.namePropertyName
        });
      }
      setDefault();
      instance.current.show();
    } else {
      instance.current.hide();
    }
    // eslint-disable-next-line
  }, [show]);

  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects
  if (instance.current) {
    instance.current.params.onClickSubmit = clickSubmit;
    instance.current.params.onClickCancel = clickCancel;
    instance.current.params.onClickMask = clickMask;
  }
  function clickSubmit(e) {
    // 获取选中项
    e.activeText = e.getActiveText(e.activeOptions);
    e.setActiveKeys(e.activeOptions);
    // Callback
    var value = e.activeText;
    var options = e.activeOptions;
    if (submitAttribute.onClick) submitAttribute.onClick(e, value, options);
  }
  function clickCancel(e) {
    if (cancelAttribute.onClick) cancelAttribute.onClick(e);
  }
  function clickMask(e) {
    if (maskAttribute.onClick) maskAttribute.onClick(e);
  }
  function scrollEnd(e) {
    // var activeOption = e.activeSlot.values[e.activeSlot.activeIndex]
    var activeOption = e.activeOptions[e.activeSlot.index];
    if (e.activeSlot.index === 0) {
      // 滚动省
      var city = e.replaceCity(activeOption[e.params.idPropertyName]); // 修改第二项
      e.replaceDistrict(city[0][e.params.idPropertyName]); // 修改第三项
    } else if (e.activeSlot.index === 1) {
      // 滚动市
      e.replaceDistrict(activeOption[e.params.idPropertyName]); // 修改第三项
    }
    // Callback
    if (onScrollEnd) onScrollEnd(e);
  }
  function setDefault() {
    if (selected && selected.length) {
      instance.current.setDefaultKeys(selected.map(function (item) {
        return item.id;
      }));
    } else {
      var defaultValues = getDefaultValues();
      instance.current.setDefaultValues(defaultValues);
    }
    instance.current.update();
  }
  function getDefaultValues() {
    // 默认值
    var defaultValue = value;
    var defaultValues = [];
    if (defaultValue) {
      defaultValues = defaultValue.split(split).map(function (item) {
        return item.trim();
      });
    }
    return defaultValues;
  }
  function getDefaultKeys() {
    if (selected && selected.length > 1) {
      return selected.map(function (item) {
        return item.id;
      });
    }
    return ['', '', ''];
  }
  function initInstance() {
    var defaultValues = getDefaultValues();
    var defaultKeys = getDefaultKeys();
    // render数据
    instance.current = new Instance({
      data: data || treeData,
      idPropertyName: dataFormat.idPropertyName,
      namePropertyName: dataFormat.namePropertyName,
      childPropertyName: dataFormat.childPropertyName,
      mask: refEl.current,
      split: split,
      viewType: type,
      defaultProvinceKey: defaultKeys[0] || '',
      defaultCityKey: defaultKeys[1] || '',
      defaultDistrictKey: defaultKeys[2] || '',
      defaultProvince: defaultValues[0] || '',
      defaultCity: defaultValues[1] || '',
      defaultDistrict: defaultValues[2] || '',
      onClickMask: clickMask,
      onClickCancel: clickCancel,
      onClickSubmit: clickSubmit,
      onScrollEnd: scrollEnd,
      onHid: function onHid(e) {}
    });
    if (show && instance.current) {
      setTimeout(function () {
        instance.current.show();
      }, 10);
    }
  }
  // 过滤已经回调的属性
  function filterProps(props) {
    if (!props) return {};
    var caption = props.caption,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded2);
    return _objectSpread({}, otherProps);
  }
  // 剔除掉onClick事件, 因为在instance时已经回调了
  var otherMaskAttribute = filterProps(maskAttribute);
  var otherSubmitAttribute = filterProps(submitAttribute);
  var otherCancelAttribute = filterProps(cancelAttribute);
  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({
    ref: refEl
  }, otherMaskAttribute), {}, {
    className: "mask picker-mask".concat(otherMaskAttribute.className ? ' ' + otherMaskAttribute.className : ''),
    children: /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, others), {}, {
      className: "picker".concat(others.className ? ' ' + others.className : ''),
      children: [/*#__PURE__*/_jsxs("div", {
        className: "picker-header",
        children: [/*#__PURE__*/_jsx("a", _objectSpread(_objectSpread({}, otherCancelAttribute), {}, {
          className: "picker-cancel".concat(cancelAttribute.className ? ' ' + cancelAttribute.className : ''),
          children: cancelAttribute.caption || locale('取消', 'cancel')
        })), /*#__PURE__*/_jsx("div", {
          className: "picker-header-title"
        }), /*#__PURE__*/_jsx("a", _objectSpread(_objectSpread({}, otherSubmitAttribute), {}, {
          className: "picker-submit".concat(submitAttribute.className ? ' ' + submitAttribute.className : ''),
          children: submitAttribute.caption || locale('完成', 'finish')
        }))]
      }), /*#__PURE__*/_jsxs("div", {
        className: "picker-wrapper",
        children: [/*#__PURE__*/_jsx("div", {
          className: "picker-layer",
          children: /*#__PURE__*/_jsx("div", {
            className: "picker-layer-frame"
          })
        }), /*#__PURE__*/_jsx("div", {
          className: "picker-slotbox"
        })]
      })]
    }))
  })), portal || context.portal || document.getElementById('root') || document.body);
});
export default /*#__PURE__*/React.memo(PickerCity, function (prevProps, nextProps) {
  if (nextProps.show === prevProps.show) return true;
  return false;
});